Summary: VIM (Vi IMproved) text editor.
Name: vim
Version: 5.6
%define ver 56
Release: 2
URL: http://www.vim.org
Copyright: freeware
Group: Applications/Editors
Source0: ftp://ftp.vim.org/pub/vim/unix/vim-%{version}-src.tar.gz
Source1: ftp://ftp.vim.org/pub/vim/unix/vim-%{version}-rt.tar.gz
Source2: vim.png
Patch0: %{name}-%{version}.patch
Buildroot: /var/tmp/%{name}-root
Buildrequires: python-devel perl gtk+-devel tcl

%description
VIM (Vi IMproved) is a text editor that is upwards compatible to Vi.  It can be
used to edit any ASCII text.  It is especially useful for editing programs.
There are a lot of enhancements above Vi: multi level undo, multi windows and
buffers, syntax highlighting, command line editing, filename completion,
on-line help, visual selection, etc..


%package common
Summary: The common files needed by any version of the VIM text editor.
Group: Applications/Editors

%description common
VIM (Vi IMproved) is a text editor that is upwards compatible to Vi.  It can be
used to edit any ASCII text.  It is especially useful for editing programs.
There are a lot of enhancements above Vi: multi level undo, multi windows and
buffers, syntax highlighting, command line editing, filename completion,
on-line help, visual selection, etc..

The vim-common package contains files which every VIM binary will need in order
to run.  If you are installing any of the other VIM packages, you'll also need
the vim-common package installed.


%package ctags
Summary: An index (or "tag") generator
Group: Applications/Editors

%description ctags
The ctags program generates an index (or "tag") file for C, C++, Eiffel,
Fortran, and Java language objects found in file(s).

Included as a separate package to avoid conflicts with any other installed
ctags/etags packages.


%package tty-minimal
Summary: A minimal version of the tty console VIM text editor.
Group: Applications/Editors
Requires: vim-common
Obsoletes: vim-minimal

%description tty-minimal
VIM (Vi IMproved) is a text editor that is upwards compatible to Vi.  It can be
used to edit any ASCII text.  It is especially useful for editing programs.
There are a lot of enhancements above Vi: multi level undo, multi windows and
buffers, syntax highlighting, command line editing, filename completion,
on-line help, visual selection, etc..

The vim-tty-minimal package includes a minimal version of the tty console VIM
text editor, which is installed into /bin/vi for use when only the root
partition is present.

This package requires the vim-common package.


%package tty-maximal
Summary: A maximal version of the tty console VIM text editor.
Group: Applications/Editors
Requires: vim-common
Obsoletes: vim-enhanced
Conflicts: vim-X11-athena vim-X11-gtk vim-X11-gnome-menus

%description tty-maximal
VIM (Vi IMproved) is a text editor that is upwards compatible to Vi.  It can be
used to edit any ASCII text.  It is especially useful for editing programs.
There are a lot of enhancements above Vi: multi level undo, multi windows and
buffers, syntax highlighting, command line editing, filename completion,
on-line help, visual selection, etc..

The vim-tty-maximal package contains a tty console version of the VIM text
editor compiled with the extra recently introduced features including the Perl,
Python and Tcl interpreters.

This package requires the vim-common package.

Remove the vim-X11-athena, vim-X11-gtk and vim-X11-gnome-menus packages before
installing to avoid package conflicts.


%package X11-athena
Summary: The Athena Widget version of the VIM text editor for the X Window System.
Group: Applications/Editors
Requires: vim-common
Obsoletes: vim-X11
Conflicts: vim-tty-maximal vim-X11-gtk 

%description X11-athena
VIM (Vi IMproved) is a text editor that is upwards compatible to Vi.  It can be
used to edit any ASCII text.  It is especially useful for editing programs.
There are a lot of enhancements above Vi: multi level undo, multi windows and
buffers, syntax highlighting, command line editing, filename completion,
on-line help, visual selection, etc..

The vim-X11-athena package contains a version of the VIM text editor which will
run within the X Window System or the tty console.  The package is compiled
with the extra recently introduced features including the Perl, Python and Tcl
interpreters.  If you install this package, you can run gvim as an X
application with an Athena Widget interface and mouse support or vim from the
tty console.

This package requires the vim-common package.

Remove the vim-tty-maximal and vim-X11-gtk packages before installing to avoid
package conflicts.


%package X11-gtk
Summary: The GTK version of the VIM text editor for the X Window System.
Group: Applications/Editors
Requires: vim-common
Obsoletes: vim-X11
Conflicts: vim-tty-maximal vim-X11-athena

%description X11-gtk
VIM (Vi IMproved) is a text editor that is upwards compatible to Vi.  It can be
used to edit any ASCII text.  It is especially useful for editing programs.
There are a lot of enhancements above Vi: multi level undo, multi windows and
buffers, syntax highlighting, command line editing, filename completion,
on-line help, visual selection, etc..

The vim-X11-gtk package contains a version of the VIM text editor which will
run within the X Window System or the tty console.  The package is compiled
with the extra recently introduced features including the Perl, Python and Tcl
interpreters.  If you install this package, you can run gvim as an X
application with a full GTK interface and mouse support or vim from the tty
console.

This package requires the vim-common package.

Remove the vim-tty-maximal and vim-X11-athena packages before installing to
avoid package conflicts.

%package X11-gnome-menus
Summary: The additional files to add the X11 versions of VIM to the GNOME System menus
Group: Applications/Editors

%description X11-gnome-menus
VIM (Vi IMproved) is a text editor that is upwards compatible to Vi.  It can be
used to edit any ASCII text.  It is especially useful for editing programs.
There are a lot of enhancements above Vi: multi level undo, multi windows and
buffers, syntax highlighting, command line editing, filename completion,
on-line help, visual selection, etc..

This package links the X11 versions of the VIM text editor to the GNOME System
menus.

%prep
%setup -q
%setup -q -T -D -b 1
%patch -p1 

%build
cd src

CFLAGS="$RPM_OPT_FLAGS" \
./configure --verbose \
	--prefix=/usr \
	--enable-min-features \
	--disable-pythoninterp \
	--disable-perlinterp \
	--disable-tclinterp \
	--with-tlib=termcap \
	--without-x \
	--enable-gui=no
make
cp vim vi
make clean

CFLAGS="$RPM_OPT_FLAGS" \
./configure --verbose \
        --prefix=/usr \
        --enable-max-features \
        --enable-pythoninterp \
        --enable-perlinterp \
        --enable-tclinterp \
        --with-x \
        --enable-gui=athena
make
cp vim vim.aw
make clean

CFLAGS="$RPM_OPT_FLAGS" \
./configure --verbose \
	--prefix=/usr \
	--enable-max-features \
	--enable-pythoninterp \
	--enable-perlinterp \
	--enable-tclinterp \
	--with-x \
	--enable-gui=gtk
make
cp vim vim.gtk
make clean

CFLAGS="$RPM_OPT_FLAGS" \
./configure --verbose \
	--prefix=/usr \
	--enable-max-features \
	--enable-pythoninterp \
	--enable-perlinterp \
	--enable-tclinterp \
	--without-x \
	--enable-gui=no
make


%install
rm -rf $RPM_BUILD_ROOT
cd src
make prefix=$RPM_BUILD_ROOT/usr install

install -d $RPM_BUILD_ROOT/bin
install -d $RPM_BUILD_ROOT/usr/share/pixmaps
install -d $RPM_BUILD_ROOT/etc/X11/applnk/Applications

install -m 755 vi $RPM_BUILD_ROOT/bin
install -m 755 vim.{aw,gtk} $RPM_BUILD_ROOT/usr/bin
install -m 644 $RPM_SOURCE_DIR/vim.png $RPM_BUILD_ROOT/usr/share/pixmaps

# GNOME link
cat > $RPM_BUILD_ROOT/etc/X11/applnk/Applications/Vim.desktop <<EOF
[Desktop Entry]
Name=VIM
Comment=VIsual editor iMproved
Exec=gvim
Icon=/usr/share/pixmaps/vim.png
Terminal=false
MultipleArgs=false
Type=Application
EOF

cd $RPM_BUILD_ROOT/bin
ln -sf vi ex
ln -sf vi rview
ln -sf vi view

cd $RPM_BUILD_ROOT/usr/bin
ln -sf vim  gvim
ln -sf gvim gview
ln -sf gvim rgview
ln -sf gvim rgvim

cd $RPM_BUILD_ROOT/usr/man/man1
ln -sf vim.1 gview.1
ln -sf vim.1 gvim.1
ln -sf vim.1 rgview.1
ln -sf vim.1 rgvim.1
ln -sf vim.1 vi.1

cd $RPM_BUILD_ROOT/usr/share/vim
install -m 644 vim%{ver}/vimrc_example.vim vimrc
install -m 644 vim%{ver}/gvimrc_example.vim gvimrc

cd $RPM_BUILD_ROOT
perl -pi -e "s,$RPM_BUILD_ROOT,," ./usr/man/man1/vim.1 ./usr/man/man1/vimtutor.1


%clean
rm -rf $RPM_BUILD_ROOT


%files common
%defattr(-,root,root)
%doc README.txt
/usr/bin/vimtutor
/usr/bin/xxd
/usr/share/vim
/usr/man/man1/vim.1
/usr/man/man1/vimtutor.1
/usr/man/man1/xxd.1


%files ctags
%defattr(-,root,root)
/usr/bin/ctags
/usr/bin/etags
/usr/man/man1/ctags.1
/usr/man/man1/etags.1


%files tty-minimal
%defattr(-,root,root)
/bin/ex
/bin/rview
/bin/vi
/bin/view
/usr/man/man1/ex.1
/usr/man/man1/rview.1
/usr/man/man1/vi.1
/usr/man/man1/view.1


%files tty-maximal
%defattr(-,root,root)
/usr/bin/rvim
/usr/bin/vim
/usr/man/man1/rvim.1


%files X11-athena
%defattr(-,root,root)
/usr/bin/vim.aw
/usr/bin/gview
/usr/bin/gvim
/usr/bin/rgview
/usr/bin/rgvim
/usr/bin/rvim
/usr/man/man1/gview.1
/usr/man/man1/gvim.1
/usr/man/man1/rgview.1
/usr/man/man1/rgvim.1
/usr/man/man1/rvim.1


%files X11-gtk
%defattr(-,root,root)
/usr/bin/vim.gtk
/usr/bin/gview
/usr/bin/gvim
/usr/bin/rgview
/usr/bin/rgvim
/usr/bin/rvim
/usr/man/man1/gview.1
/usr/man/man1/gvim.1
/usr/man/man1/rgview.1
/usr/man/man1/rgvim.1
/usr/man/man1/rvim.1


%files X11-gnome-menus
%defattr(-,root,root)
/usr/share/pixmaps/vim.png
/etc/X11/applnk/Applications/Vim.desktop


%post X11-athena
cd /usr/bin
ln -sfv vim.aw vim


%post X11-gtk
cd /usr/bin
ln -sfv vim.gtk vim


%postun X11-athena
rm -fv /usr/bin/vim


%postun X11-gtk
rm -fv /usr/bin/vim


%changelog
* Sun Jan 23 2000 Pierre Scotney <pierre@mail.medstv.unimelb.edu.au>
- renamed packages to be more descriptive
- made it clear that X11 packages can also run in the tty console
- forced package conflicts between tty and X11 version packages so that only
  one binary package can be installed
- changes suggested by Bram Moolenaar <Bram@moolenaar.net> and
  Andy Kahn <ackahn@netapp.com>

* Wed Jan 19 2000 Pierre Scotney <pierre@mail.medstv.unimelb.edu.au>
- updated to vim-5.6
- created both Athena Widget and GTK X11 packages
- added VIM to GNOME System Menus with vim-gnome package
- fixed more dependency problems

* Tue Jul 27 1999 Michael K. Johnson <johnsonm@redhat.com>
- moved from athena to gtk widgets for X version
- removed vim.1 from X11 filelist because X11 depends on vim-common anyway
- fixed rogue dependencies from sample files

* Tue Jul 27 1999 Jeff Johnson <jbj@redhat.com>
- update to 5.4.

* Thu Jul 22 1999 Jeff Johnson <jbj@redhat.com>
- man page had buildroot pollution (#3629).

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- with recent termcap/terminfo fixes, regular vim works in xterm/console
- in color, so vim-color package removed.

* Tue Mar 23 1999 Erik Troan <ewt@redhat.com>
- removed "set backupdir=/tmp/vim_backup" from default vimrc

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 5)

* Thu Dec 17 1998 Michael Maher <mike@redaht.com>
- built pacakge for 6.0

* Tue Sep 15 1998 Michael Maher <mike@redhat.com>
- removed '--with-tlib=termcap' so that color-vim works

* Wed Sep  2 1998 Jeff Johnson <jbj@redhat.com>
- update to 5.3.

* Mon Aug 10 1998 Jeff Johnson <jbj@redhat.com>
- merge in Toshio's changes
- color-vim: changed "--disable-p" to "--disable-perlinterp --with-tlib=termcap"
- added minimal rvi/rview and man pages.
- move Obsoletes to same package as executable.

* Thu Aug 06 1998 Toshio Kuratomi <badger@prtr-13.ucsc.edu>
- Break the package apart similar to the way the netscape package was
  broken down to handle navigator or communicator: The vim package is
  Obsolete, now there is vim-common with all the common files, and a
  package for each binary: vim-minimal (has /bin/vi compiled with no
  frills), vim-enhanced (has /usr/bin/vim with extra perl and python
  interpreters), and vim-X11 (has /usr/X11R6/bin/gvim compiled with
  GUI support.)
- Enable the perl and python interpreters in the gui version (gvim).

* Tue Jun 30 1998 Michael Maher <mike@redhat.com>
- Fixed tutor help.
- cvim package added.  Thanks to Stevie Wills for finding this one :-)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Fri May 01 1998 Donnie Barnes <djb@redhat.com>
- added patch to turn off the "vi compatibility" by default.  You can
  still get it via the -C command line option

* Thu Apr 23 1998 Donnie Barnes <djb@redhat.com>
- removed perl and python interpreters (sorry, but those don't belong
  in a /bin/vi and having two vi's seemed like overkill...complain
  to suggest@redhat.com if you care)

* Fri Apr 17 1998 Donnie Barnes <djb@redhat.com>
- fixed buildroot bug

* Sat Apr 11 1998 Donnie Barnes <djb@redhat.com>
- updated from 4.6 to 5.1
- moved to buildroot

* Sun Nov 09 1997 Donnie Barnes <djb@redhat.com>
- fixed missing man page

* Wed Oct 22 1997 Donnie Barnes <djb@redhat.com>
- added wmconfig entry to vim-X11

* Mon Oct 20 1997 Donnie Barnes <djb@redhat.com>
- upgraded from 4.5 to 4.6

* Fri Jun 13 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Mar 25 1997 Michael K. Johnson <johnsonm@redhat.com>
- Upgraded to 4.5
- Added ex symlinks

* Tue Mar 11 1997 Michael K. Johnson <johnsonm@redhat.com>
- Added view symlink.

